Subject: bug#33729: 27.0.50; Partial glyphs not rendered for Gujarati with Harfbuzz enabled (renders fine using m17n)

From: Khaled Hosny <[email-masked]>
Date: Sun, 23 Dec 2018 15:51:09 +0200

On Sun, Dec 23, 2018 at 05:34:04AM +0200, Eli Zaretskii wrote:
> > Date: Sat, 22 Dec 2018 22:59:48 +0200
> > From: Khaled Hosny <[email-masked]>
> > Cc: [email-masked], [email-masked], [email-masked],
> > 	[email-masked], [email-masked]
> > 
> > On Sat, Dec 22, 2018 at 09:38:43PM +0200, Eli Zaretskii wrote:
> > > > Date: Sat, 22 Dec 2018 17:49:45 +0200
> > > > From: Khaled Hosny <[email-masked]>
> > > > Cc: [email-masked], [email-masked], [email-masked],
> > > > 	[email-masked], [email-masked]
> > > > 
> > > > Yes, the standard Unicode composition and decomposition. HarfBuzz uses
> > > > these during shaping (it prefers composed form for a given sequence if
> > > > supported by the font, and falls back to decomposed form otherwise).
> > > 
> > > Btw, how is this problem solved in the other projects that use
> > > Harfuzz?  Does every project need to provide this functionality, or
> > > does Harfuzz have it built-in, like with the script tags?  If there's
> > > built-in support for this, perhaps Emacs could just use that?
> > 
> > There is built-in support, and currently we are using that. I can just
> > remove the FIXME.
> 
> Are there any disadvantages in using the built-in support?  I mean,
> why did you envision an Emacs-specific implementation in the first
> place?

I thought, but I might be mistaken, that Emacs allow changing these
character properties at runtime and someone might possibly want to use
that to change some character property (e.g. make some PUA character a
combining mark) and it would then be nice if HarfBuzz respected that. I
admit that is very niche thing if possible at all, and I’m more than
happy to let HarfBuzz use it default Unicode functions and simplify the
Emacs integration code.

Regards,
Khaled